
--[[ string constants ]]--
--[[ put all the strings that might require translation in ]]--
--[[ one location for easier access ]]--
helpString = "Travel\n\ntrav show: Zeigt das Travel-Fenster an\n" ..
            "trav hide: Versteckt das Travel-Fenster\n" ..
            "trav toggle: Schaltet das Travel-Fenster um\n";

-- window title strings
mainTitleString = "Travel";
optionsTitleString = "Travel Optionen";
moorMapTitleString = "Kartenorte";
eriadorMapTitleString = "Eriador-Orte"; 
rhovanionMapTitleString = "Rhovanion-Orte";

-- strings for maps
mapHomeString = "Karte zum Ausgangspunkt";
glanMapString = "Genaue Karte nach Glân Vraig";
glanMapItemString = "Genaue Karte nach Glân Vraig";

-- travel ration strings
rationItemString = "Reiseration";
rationLabelString = "Reiserationen:";

-- adding map strings
mapInstructionString =  "Ziehe deine Karten aus deinem Inventar in den  " ..
                           "Quickslot unten. Dann drücke den Button " ..
	                        "um deine Karte zu setzen.";
mapErrorString = "Keine Karten gefunden, keine Aktualisierungen durchgeführt.";

-- error messages
resetOrderString = "Deine Sortiereinstellungen wurden aufgrund einer Änderung der Anzahl" ..
                  "der zu speichernden Elemente zurückgesetzt. Dies sollte nur einmal passieren.\n" ..
                  "Entschuldigung für die Unannehmlichkeiten.";
                  
resetEnabledString = "Deine ausgewählten Fertigkeiten wurden aufgrund eines Fehlers " ..
                  "auf die Zahl der zuletzt gespeicherten zurückgesetzt.\n";

-- options window strings
generalTabString = "Allgemein";
selectTabString = "Auswählen"; 
sortTabString = "Sortieren";
hideString = "Verstecke Travel-Fenster am Start";
toggleString = "Zeige Umschalt-Button";
pulldownTravelString = "Reise wenn Pulldown-Fertigkeit selektiert";
hideOnCombatString = "Verstecke Fenster wenn in Kampf";
genericLabelString = "Generische Fertigkeiten";
racialLabelString = "Rassenfertigkeiten";
classLabelString = "Klassenfertigkeiten";
repLabelString = "Ruffertigkeiten";
moveUpString = "hoch";
moveDownString = "runter";
moveTopString = "zum Anfang";
moveBottomString = "zum Ende";
toggleSlidersString = "Umschalt-Button Transparenz";
mainSlidersString = "Hauptfenster Transparenz";
minString = "Min: ";
maxString = "Max: ";
resetSettingsString = "Rücksetzen auf Standard";

-- menu strings
menuFiltersString = "Filter";
menuGenString = "Zeige generische Reisen";
menuRaceString = "Zeige Rassenreisen";
menuRepString = "Zeige Rufreisen";
menuClassString = "Zeige Klassenreisen";
menuModeString = "Modus";
menuTextString = "Liste";
menuIconString = "Icon-Gitternetz";
menuCaroString = "Karussell";
menuPullString = "Pulldown-Liste";
menuMapString = "Karte hinzufuegen";   
menuOptionsString = "Optionen";
moorMapString = "Öffne Etten-Karte";
eriadorMapString = "Öffne Eriador-Karte";
rhovanionMapString = "Öffne Rhovanion-Karte";

--[[ travel skills ]]--
--[[ Add all the travel skills ]]--
TravelDictionaries = class()

function TravelDictionaries:Constructor()

	-- create the indexed tables that store all the data
	genLocations = IndexedDictionary();	
	hunterLocations = IndexedDictionary();
	wardenLocations = IndexedDictionary();
	racialLocations = IndexedDictionary();
	repLocations = IndexedDictionary();
	creepLocations = IndexedDictionary();
	
	-- a table to store the number of each type of travel skill
	travelCount = {0,0,0,0,0,0};
	totalLocations = 0;
	
	self:CreateDictionaries();
   self:GetCounts();	
end

-- function to count the number of skills in total
function TravelDictionaries:GetCounts()
	travelCount[1] = hunterLocations:GetCount();	
	travelCount[2] = wardenLocations:GetCount();
	travelCount[3] = genLocations:GetCount();
	travelCount[4] = repLocations:GetCount();
	travelCount[5] = racialLocations:GetCount();
	travelCount[6] = creepLocations:GetCount();
	
	totalLocations = travelCount[1] + travelCount[2] + travelCount[3] + travelCount[4] + travelCount[5];	
end

-- function to return the count of a specific type of travel
function TravelDictionaries:GetCount(index)
	return travelCount[index];
end

-- function to get the total number of travel skills
function TravelDictionaries:GetTotalCount()
   return totalLocations;
end

-- function to return the 5 tables containing the travel skills
function TravelDictionaries:GetLocations()
	return genLocations, hunterLocations, wardenLocations, racialLocations, repLocations;
end

function TravelDictionaries:CreateDictionaries()
	-- add the data to custom dictionaries to maintain the order

	hunterLocations:AddData("Zurück zum Lager","0x7000A2C1");
	hunterLocations:AddData("Führer nach Bree","0x70003F42");
	hunterLocations:AddData("Führer zu Thorins Halle","0x70003F41");
	hunterLocations:AddData("Führer nach Michelbinge","0x7000A2C3");
	hunterLocations:AddData("Führer nach Esteldín","0x70003F43");
	hunterLocations:AddData("Führer nach Evendim","0x7000A2C4");
	hunterLocations:AddData("Führer zur Feste Guruth","0x7000A2C2");
	hunterLocations:AddData("Führer nach Bruchtal","0x70003F44");
	hunterLocations:AddData("Führer nach Sûri-Kylä","0x70017C82");
	hunterLocations:AddData("Führer nach West-Angmar","0x7000A2C5");
	hunterLocations:AddData("Führer nach Ost-Angmar","0x7000A2C6");
	hunterLocations:AddData("Führer nach Echad Dúnann","0x70017C81");
	hunterLocations:AddData("Führer zur 21. Halle","0x70017C7A");
	hunterLocations:AddData("Führer zur Dunkelsenke","0x7001F459");
	hunterLocations:AddData("Führer nach Harndirion","0x700235EF");
	hunterLocations:AddData("Führer nach Galtrev","0x7002A93F");
	hunterLocations:AddData("Führer nach Stangard","0x7002C62C");

	wardenLocations:AddData("Appell in der Feste Guruth","0x70014786");
	wardenLocations:AddData("Appell in Esteldín","0x70014798");
	wardenLocations:AddData("Appell in Evendim","0x7001478E");
	wardenLocations:AddData("Appell in Bruchtal","0x70014791");	
	wardenLocations:AddData("Appell in Sûri-Kylä","0x700237D4");
	wardenLocations:AddData("Appell in der 21. Halle","0x7001819E");
	wardenLocations:AddData("Appell in der Dunkelsenke","0x7001F45C");
	wardenLocations:AddData("Appell in Harndirion","0x700235EB");
   wardenLocations:AddData("Appell in Galtrev","0x7002A90A");					
	wardenLocations:AddData("Appell in Stangard","0x7002C646");	

	racialLocations:AddData("Rückkehr nach Bree","0x700062F6");
	racialLocations:AddData("Rückkehr ins Auenland","0x700062C8");
	racialLocations:AddData("Rückkehr zu Thorins Tor","0x70006346");
	racialLocations:AddData("Rückkehr nach Bruchtal","0x7000631F");	

   -- check if a function that only exists in the newest update exists,
   -- if so, add the Return Home skills
   if(Turbine.UI.Control.IsDisplayed ~= nil) then
	  genLocations:AddData("zum 1. Heim zurückkehren","0x700256BA");
	  genLocations:AddData("zum 2. Heim zurückkehren","0x70025792");
	  genLocations:AddData("zum 3. Heim zurückkehren","0x70025793");
	  genLocations:AddData("zum 4. Heim zurückkehren","0x70025794");
	  genLocations:AddData("zum 5. Heim zurückkehren","0x70025795");
	  genLocations:AddData("zum 6. Heim zurückkehren","0x70025796");
	end
	genLocations:AddData("Eigenes Haus","0x7000D046");
	genLocations:AddData("Sippenhaus","0x7000D047");

	repLocations:AddData("Rückkehr nach Thorins Tor (Ruf)","0x7001BF91");
	repLocations:AddData("Rückkehr nach Bree (Ruf)","0x7001BF90");
	repLocations:AddData("Rückkehr ins Auenland (Ruf)","0x70023262");
	repLocations:AddData("Rückkehr nach Bruchtal (Ruf)","0x70023263");
	repLocations:AddData("Rückkehr zur Feste Guruth (Ruf)","0x70020441");
	repLocations:AddData("Rückkehr nach Düsterwald (Ruf)","0x7001F374");
	repLocations:AddData("Rückkehr nach Enedwaith (Ruf)","0x70021FA2");
	repLocations:AddData("Rückkehr nach Galtrev (Ruf)","0x7002C647");
	repLocations:AddData("Rückkehr nach Stangard (Ruf)","0x7002C65D");
	                           
	creepLocations:AddData("Grobe Isenbinge-Karte","0x70028BB3");
	creepLocations:AddData("Grobe Tol Ascarnen-Karte","0x70028BB6");
	creepLocations:AddData("Grobe Karte zum Lugazag","0x70028BB7");
	creepLocations:AddData("Grobe Karte nach Gramfuß","0x70028BBC");
	creepLocations:AddData("Grobe Tirith Rhaw-Karte","0x70028BBE");
	creepLocations:AddData("Grobe Karte nach Grimmwald","0x70028BBF");
	creepLocations:AddData("Minderwertige Isenbinge-Karte","0x70028BAF");
	creepLocations:AddData("Minderwertige Karte zum Tol Ascarnen","0x70028BB1");
	creepLocations:AddData("Minderwertige Karte zum Lugazag","0x70028BB2");
	creepLocations:AddData("Minderwertige Tirith-Rhaw-Karte","0x70028BB4");
	creepLocations:AddData("Minderwertige Karte nach Grimmwald","0x70028BB9");
	creepLocations:AddData("Gute Isenbinge-Karte","0x70028BC0");
	creepLocations:AddData("Gute Tol Ascarnen-Karte","0x70028BC2");
	creepLocations:AddData("Gute Lugazag-Karte","0x70028BB5");                                     
	creepLocations:AddData("Karte nach Gramfuß","0x70028BC1");
	creepLocations:AddData("Gute Karte zum Tirith Rhaw","0x70028BB0");
	creepLocations:AddData("Gute Grimmwald-Karte","0x70028BBD");

end


--[[ use a modified table that can maintain a key value for each entry ]]--
IndexedDictionary = class() 

function IndexedDictionary:Constructor()

   -- set default tables
	self.listOfKeys = { };
	self.dataPairs = { };
	self.numberOfPairs = 0;
end

-- function to get the total number of entries in the dictionary
function IndexedDictionary:GetCount()
	return self.numberOfPairs;
end

-- function to add a key/data pair to the end of the dictionary
function IndexedDictionary:AddData(key, data)
   -- increase the counter
	self.numberOfPairs = self.numberOfPairs + 1;

   -- insert the key into the list of keys
	table.insert(self.listOfKeys,key);
	-- add the key/data into the table
	self.dataPairs[key] = data;

end

-- function to add a key/data pair at a specific index
function IndexedDictionary:InsertData(index, key, data)
   -- increase the counter
	self.numberOfPairs = self.numberOfPairs + 1;

   -- add the key to the list of keys at the specified index
	table.insert(self.listOfKeys, index, key);
	-- add the key/data into the table
	self.dataPairs[key] = data;
end

-- function to remove a key/data pair at an index
function IndexedDictionary:RemoveAtIndex(index)
	
	self.location = 0;
	self.counter = 0;

   -- loop through the main table	
	for k,v in pairs(self.dataPairs) do
		self.counter = self.counter + 1;
		
		-- if the keys match, set the location to remove from the table
		if(k == self.listOfKeys[index]) then
			self.location = self.counter;
		end
	end

   -- remove the item and the key from the tables
	table.remove(self.dataPairs,self.location);
	table.remove(self.listOfKeys,index);

   -- decrease the counters
	self.numberOfPairs = self.numberOfPairs - 1;
end

-- function to get the key at a specified index
function IndexedDictionary:KeyAtIndex(index)
	local string = self.listOfKeys[index];
	return string;
end

-- function to return the data at a specified index
function IndexedDictionary:DataAtIndex(index)
	local string = self.listOfKeys[index];
	local data = self.dataPairs[string];

	return data;
end

-- function to return the data pair at an index
function IndexedDictionary:PairAtIndex(index)
	local string = self.listOfKeys[index];
	local data = self.dataPairs[string];

	return string,data;
end

-- function to get the data by a key value
function IndexedDictionary:DataByKey(key)
	return self.dataPairs[key];
end

-- function to find the index value based on a key
function IndexedDictionary:IndexByKey(key)

   -- return if the list of keys is empty
	if(self.listOfKeys == { }) then
		return -1;
	end

   -- loop through the list of keys and search for the key value
	for i = 1,table.getn(self.listOfKeys),1 do
	   -- return the index value if a match is made
		if(self.listOfKeys[i] == key) then
			return i;
		end
	end
	
	-- return -1 since we did not find a key
	return -1;
end


